//
//  TableViewController.m
//  CountryDB
//
//  Created by Holger Hinzberg on 23.02.12.
//  Copyright (c) 2012 Cocoa-Coding. All rights reserved.
//

#import "TableViewController.h"

@interface TableViewController ()

@end

@implementation TableViewController

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.navigationItem.title = @"Länder";
    self.navigationItem.prompt = @"CountryDB - Alle meine Länder";
    
    countryArray = [[NSMutableArray alloc] init];
    
    // DetailViewController instanziieren und die 
    // Datei der grafischen Oberfläche zuweisen.
    countryView = [[DetailViewController alloc]
    initWithNibName:@"DetailViewController" bundle:nil];
    
    
    
    Country *aCounty;
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Deutschland";
    aCounty.capital = @"Berlin";
    aCounty.area = @"357.021 km\u00b2";
    aCounty.population = @"81.757.600";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Frankreich";
    aCounty.capital = @"Paris";
    aCounty.area = @"674.843 km\u00b2";
    aCounty.population =@"65.447.374";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Italien";
    aCounty.capital = @"Rom";
    aCounty.area = @"301.338 km\u00b2";
    aCounty.population = @"60.418.711";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Japan";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Spanien";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Brasilien";
    [countryArray addObject:aCounty];
    
    aCounty = [[Country alloc] init];
    aCounty.countryName = @"Norwegen";
    [countryArray addObject:aCounty];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:
  (UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return countryArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (cell == nil)
    {
        cell = [[UITableViewCell alloc]
                 initWithStyle:UITableViewCellStyleDefault
                 reuseIdentifier:CellIdentifier];
    }
    
    Country *aCounty = 
    [countryArray objectAtIndex:indexPath.row];
    cell.textLabel.text = aCounty.countryName;
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // 1. Das passende Objekt holen
    Country *aCounty = 
    [countryArray objectAtIndex:indexPath.row];
    
    // 2. Das Land an die Detailansicht übergeben
    countryView.aCountry = aCounty;
    
    // 3. Anzeigen
    [self.navigationController pushViewController:
     countryView animated:YES];
}

- (void)tableView:(UITableView *)tableView willDisplayCell:
  (UITableViewCell *)cell forRowAtIndexPath:
  (NSIndexPath*)indexPath
{
    cell.textLabel.textColor = [UIColor blueColor];
    
    UIColor *background;
    
    if (indexPath.row % 2 == 0)
    {
        background =
        [[UIColor alloc] initWithRed:0.9 green:0.9 blue:0.9 
                               alpha:1];
    }
    else
    {
        background =
        [[UIColor alloc] initWithRed:0.8 green:0.8 blue:0.8 
                               alpha:1];
    }
    cell.backgroundColor = background;
}

@end
